From 2b4c6efc82119ba8f4169717473d95d1a89e4c69 Mon Sep 17 00:00:00 2001
From: Johannes Schindelin <johannes.schindelin@gmx.de>
Date: Tue, 16 Dec 2014 23:46:59 +0100
Subject: [PATCH 12/13] read-cache: optionally disallow NTFS .git variants

The point of disallowing ".git" in the index is that we
would never want to accidentally overwrite files in the
repository directory. But this means we need to respect the
filesystem's idea of when two paths are equal. The prior
commit added a helper to make such a comparison for NTFS
and FAT32; let's use it in verify_path().

We make this check optional for two reasons:

  1. It restricts the set of allowable filenames, which is
     unnecessary for people who are not on NTFS nor FAT32.
     In practice this probably doesn't matter, though, as
     the restricted names are rather obscure and almost
     certainly would never come up in practice.

  2. It has a minor performance penalty for every path we
     insert into the index.

This patch ties the check to the core.protectNTFS config
option. Though this is expected to be most useful on Windows,
we allow it to be set everywhere, as NTFS may be mounted on
other platforms. The variable does default to on for Windows,
though.

Signed-off-by: Johannes Schindelin <johannes.schindelin@gmx.de>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
---
 Documentation/config.txt       |    6 ++++++
 cache.h                        |    1 +
 config.c                       |    5 +++++
 environment.c                  |    5 +++++
 read-cache.c                   |    2 ++
 t/t1014-read-tree-confusing.sh |   13 +++++++++++++
 6 files changed, 32 insertions(+)

--- a/Documentation/config.txt
+++ b/Documentation/config.txt
@@ -228,6 +228,12 @@ core.protectHFS::
 	be considered equivalent to `.git` on an HFS+ filesystem.
 	Defaults to `true` on Mac OS, and `false` elsewhere.
 
+core.protectNTFS::
+	If set to true, do not allow checkout of paths that would
+	cause problems with the NTFS filesystem, e.g. conflict with
+	8.3 "short" names.
+	Defaults to `true` on Windows, and `false` elsewhere.
+
 core.trustctime::
 	If false, the ctime differences between the index and the
 	working tree are ignored; useful when the inode change time
--- a/cache.h
+++ b/cache.h
@@ -557,6 +557,7 @@ extern int core_preload_index;
 extern int core_apply_sparse_checkout;
 extern int precomposed_unicode;
 extern int protect_hfs;
+extern int protect_ntfs;
 
 enum branch_track {
 	BRANCH_TRACK_UNSPECIFIED = -1,
--- a/config.c
+++ b/config.c
@@ -768,6 +768,11 @@ static int git_default_core_config(const
 		return 0;
 	}
 
+	if (!strcmp(var, "core.protectntfs")) {
+		protect_ntfs = git_config_bool(var, value);
+		return 0;
+	}
+
 	/* Add other config variables here and to Documentation/config.txt. */
 	return 0;
 }
--- a/environment.c
+++ b/environment.c
@@ -67,6 +67,11 @@ unsigned long pack_size_limit_cfg;
 #endif
 int protect_hfs = PROTECT_HFS_DEFAULT;
 
+#ifndef PROTECT_NTFS_DEFAULT
+#define PROTECT_NTFS_DEFAULT 0
+#endif
+int protect_ntfs = PROTECT_NTFS_DEFAULT;
+
 /* Parallel index stat data preload? */
 int core_preload_index = 0;
 
--- a/read-cache.c
+++ b/read-cache.c
@@ -768,6 +768,8 @@ int verify_path(const char *path)
 inside:
 			if (protect_hfs && is_hfs_dotgit(path))
 				return 0;
+			if (protect_ntfs && is_ntfs_dotgit(path))
+				return 0;
 			c = *path++;
 			if ((c == '.' && !verify_dotfile(path)) ||
 			    is_dir_sep(c) || c == '\0')
--- a/t/t1014-read-tree-confusing.sh
+++ b/t/t1014-read-tree-confusing.sh
@@ -15,8 +15,17 @@ test_expect_success 'enable core.protect
 	git config core.protectHFS true
 '
 
+test_expect_success 'enable core.protectNTFS for rejection tests' '
+	git config core.protectNTFS true
+'
+
 while read path pretty; do
 	: ${pretty:=$path}
+	case "$path" in
+	*SPACE)
+		path="${path%SPACE} "
+		;;
+	esac
 	test_expect_success "reject $pretty at end of path" '
 		printf "100644 blob %s\t%s" "$blob" "$path" >tree &&
 		bogus=$(git mktree <tree) &&
@@ -36,6 +45,10 @@ done <<-EOF
 ${u200c}.Git {u200c}.Git
 .gI${u200c}T .gI{u200c}T
 .GiT${u200c} .GiT{u200c}
+git~1
+.git.SPACE .git.{space}
+.\\\\.GIT\\\\foobar backslashes
+.git\\\\foobar backslashes2
 EOF
 
 test_expect_success 'utf-8 paths allowed with core.protectHFS off' '
